/**************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto , (c)2004 by 421                 *
*   ikemo@wakaba.jp                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/

#ifndef KITADATMG_H
#define KITADATMG_H

#include <qstringlist.h>
#include <kurl.h>

class QSemaphore;

namespace Kita
{

#define DMANAGER_MAXQUEUE 15

    enum{
        ABONECHK_BY_ID,
        ABONECHK_BY_NAME,
        ABONECHK_BY_WORD
    };

    /*-----------------------*/

    class DatInfo
    {
        int m_maxNum;
        KURL m_url;
        QString m_subject;
        QStringList m_linedat;
        QStringList m_idlist;

    public:
        DatInfo();
        DatInfo( const KURL& url );
        const QString& getDat( int num );
        const QString& getId( int num );
        const QString& getSubject() { return m_subject;}
        KURL& url() { return m_url;};
        int getMaxResNumber() { return m_maxNum;}
    };

    /*-----------------------*/
    typedef QValueList<DatInfo*> DatInfoList;

    class DatManager
    {
        static DatInfoList m_datInfo;
        static QSemaphore m_semap;

    public:
        static void deleteDat( const KURL& url );
        static const QString& getDat( const KURL& url, int num );
        static const QString& getSubject( const KURL& url );
        static QString getHtml( const KURL& url, int startnum, int endnum );
        static int getNumByID( const KURL& url, QString strid );
        static int getMaxResNumber( const KURL& url );

        static bool checkAbone( const QString& str, int mode );

    private:
        static DatInfo* getDatInfo( const KURL& url );
    };


}

#endif
