/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto                                  *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/

#ifndef KITAHTMLPART_H
#define KITAHTMLPART_H

#include <kurl.h>
#include <khtml_part.h>

#include <qstringlist.h>

#include <qvaluestack.h> // for gcc-2.9x
template <class T> class QValueStack;

namespace Kita
{
    class Thread;
}

class KPopupMenu;

#include <qstringlist.h>
class KitaDomTree;
class KitaThreadView;

/**
@author Hideki Ikemoto
*/
class KitaHTMLPart : public KHTMLPart
{
    Q_OBJECT

    QWidget* m_parent;
    KPopupMenu* m_popupMenu;
    bool m_pushctrl;
    bool m_pushmidbt;
    KitaDomTree* m_domtree;
    KitaThreadView* m_threadView;
    Kita::Thread* m_thread;
    QStringList m_anchorStack;

public:
    void pushCurrentPosition();
    bool gotoAnchor( const QString& name );

    KitaHTMLPart( QWidget* parent, const char* name = 0 );
    ~KitaHTMLPart();
    void setupEx( KitaThreadView* threadView, KitaDomTree* domtree,
                  Kita::Thread* thread );
    void gotoKokoyon();

protected:
    virtual void khtmlMousePressEvent( khtml::MousePressEvent* e );
    virtual void khtmlMouseReleaseEvent( khtml::MouseReleaseEvent *e );
    virtual void khtmlMouseMoveEvent( khtml::MouseMoveEvent* e );

public slots:
    bool gobackAnchor();

private slots:
    void slotPopupMenu( const QString& url, const QPoint& point );

signals:
    void setLocationBarURL( const QString &url );
};

#endif
